"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.envVars = exports.EnvVars = exports.SUPPORTED_ENV_VARS = exports.EnvironmentVariable = void 0;
/*
 * Copyright (c) 2020, salesforce.com, inc.
 * All rights reserved.
 * Licensed under the BSD 3-Clause license.
 * For full license text, see LICENSE.txt file in the repo root or https://opensource.org/licenses/BSD-3-Clause
 */
const path_1 = require("path");
const change_case_1 = require("change-case");
const kit_1 = require("@salesforce/kit");
const messages_1 = require("../messages");
const global_1 = require("../global");
messages_1.Messages.importMessagesDirectory((0, path_1.join)(__dirname));
const messages = messages_1.Messages.loadMessages('@salesforce/core', 'envVars');
var EnvironmentVariable;
(function (EnvironmentVariable) {
    EnvironmentVariable["FORCE_OPEN_URL"] = "FORCE_OPEN_URL";
    EnvironmentVariable["FORCE_SHOW_SPINNER"] = "FORCE_SHOW_SPINNER";
    EnvironmentVariable["FORCE_SPINNER_DELAY"] = "FORCE_SPINNER_DELAY";
    EnvironmentVariable["HTTP_PROXY"] = "HTTP_PROXY";
    EnvironmentVariable["HTTPS_PROXY"] = "HTTPS_PROXY";
    EnvironmentVariable["NODE_EXTRA_CA_CERTS"] = "NODE_EXTRA_CA_CERTS";
    EnvironmentVariable["NODE_TLS_REJECT_UNAUTHORIZED"] = "NODE_TLS_REJECT_UNAUTHORIZED";
    EnvironmentVariable["SFDX_ACCESS_TOKEN"] = "SFDX_ACCESS_TOKEN";
    EnvironmentVariable["SFDX_API_VERSION"] = "SFDX_API_VERSION";
    EnvironmentVariable["SFDX_AUDIENCE_URL"] = "SFDX_AUDIENCE_URL";
    EnvironmentVariable["SFDX_CODE_COVERAGE_REQUIREMENT"] = "SFDX_CODE_COVERAGE_REQUIREMENT";
    EnvironmentVariable["SFDX_CONTENT_TYPE"] = "SFDX_CONTENT_TYPE";
    EnvironmentVariable["SFDX_DEFAULTDEVHUBUSERNAME"] = "SFDX_DEFAULTDEVHUBUSERNAME";
    EnvironmentVariable["SFDX_DEFAULTUSERNAME"] = "SFDX_DEFAULTUSERNAME";
    EnvironmentVariable["SFDX_DISABLE_AUTOUPDATE"] = "SFDX_DISABLE_AUTOUPDATE";
    EnvironmentVariable["SFDX_AUTOUPDATE_DISABLE"] = "SFDX_AUTOUPDATE_DISABLE";
    EnvironmentVariable["SFDX_DISABLE_SOURCE_MEMBER_POLLING"] = "SFDX_DISABLE_SOURCE_MEMBER_POLLING";
    EnvironmentVariable["SFDX_DISABLE_TELEMETRY"] = "SFDX_DISABLE_TELEMETRY";
    EnvironmentVariable["SFDX_DNS_TIMEOUT"] = "SFDX_DNS_TIMEOUT";
    EnvironmentVariable["SFDX_DOMAIN_RETRY"] = "SFDX_DOMAIN_RETRY";
    EnvironmentVariable["SFDX_IMPROVED_CODE_COVERAGE"] = "SFDX_IMPROVED_CODE_COVERAGE";
    EnvironmentVariable["SFDX_INSTANCE_URL"] = "SFDX_INSTANCE_URL";
    EnvironmentVariable["SFDX_JSON_TO_STDOUT"] = "SFDX_JSON_TO_STDOUT";
    EnvironmentVariable["SFDX_LOG_LEVEL"] = "SFDX_LOG_LEVEL";
    EnvironmentVariable["SFDX_LOG_ROTATION_COUNT"] = "SFDX_LOG_ROTATION_COUNT";
    EnvironmentVariable["SFDX_LOG_ROTATION_PERIOD"] = "SFDX_LOG_ROTATION_PERIOD";
    EnvironmentVariable["SFDX_MAX_QUERY_LIMIT"] = "SFDX_MAX_QUERY_LIMIT";
    EnvironmentVariable["SFDX_MDAPI_TEMP_DIR"] = "SFDX_MDAPI_TEMP_DIR";
    EnvironmentVariable["SFDX_NPM_REGISTRY"] = "SFDX_NPM_REGISTRY";
    EnvironmentVariable["SFDX_PRECOMPILE_ENABLE"] = "SFDX_PRECOMPILE_ENABLE";
    EnvironmentVariable["SFDX_PROJECT_AUTOUPDATE_DISABLE_FOR_PACKAGE_CREATE"] = "SFDX_PROJECT_AUTOUPDATE_DISABLE_FOR_PACKAGE_CREATE";
    EnvironmentVariable["SFDX_PROJECT_AUTOUPDATE_DISABLE_FOR_PACKAGE_VERSION_CREATE"] = "SFDX_PROJECT_AUTOUPDATE_DISABLE_FOR_PACKAGE_VERSION_CREATE";
    EnvironmentVariable["SFDX_REST_DEPLOY"] = "SFDX_REST_DEPLOY";
    EnvironmentVariable["SFDX_SOURCE_MEMBER_POLLING_TIMEOUT"] = "SFDX_SOURCE_MEMBER_POLLING_TIMEOUT";
    EnvironmentVariable["SFDX_USE_GENERIC_UNIX_KEYCHAIN"] = "SFDX_USE_GENERIC_UNIX_KEYCHAIN";
    EnvironmentVariable["SFDX_USE_PROGRESS_BAR"] = "SFDX_USE_PROGRESS_BAR";
    EnvironmentVariable["SFDX_LAZY_LOAD_MODULES"] = "SFDX_LAZY_LOAD_MODULES";
    EnvironmentVariable["SFDX_S3_HOST"] = "SFDX_S3_HOST";
    EnvironmentVariable["SFDX_UPDATE_INSTRUCTIONS"] = "SFDX_UPDATE_INSTRUCTIONS";
    EnvironmentVariable["SFDX_INSTALLER"] = "SFDX_INSTALLER";
    EnvironmentVariable["SFDX_ENV"] = "SFDX_ENV";
    EnvironmentVariable["SF_TARGET_ORG"] = "SF_TARGET_ORG";
    EnvironmentVariable["SF_TARGET_DEV_HUB"] = "SF_TARGET_DEV_HUB";
    EnvironmentVariable["SF_ACCESS_TOKEN"] = "SF_ACCESS_TOKEN";
    EnvironmentVariable["SF_ORG_API_VERSION"] = "SF_ORG_API_VERSION";
    EnvironmentVariable["SF_AUDIENCE_URL"] = "SF_AUDIENCE_URL";
    EnvironmentVariable["SF_CODE_COVERAGE_REQUIREMENT"] = "SF_CODE_COVERAGE_REQUIREMENT";
    EnvironmentVariable["SF_CONTENT_TYPE"] = "SF_CONTENT_TYPE";
    EnvironmentVariable["SF_DISABLE_AUTOUPDATE"] = "SF_DISABLE_AUTOUPDATE";
    EnvironmentVariable["SF_AUTOUPDATE_DISABLE"] = "SF_AUTOUPDATE_DISABLE";
    EnvironmentVariable["SF_DISABLE_SOURCE_MEMBER_POLLING"] = "SF_DISABLE_SOURCE_MEMBER_POLLING";
    EnvironmentVariable["SF_DISABLE_TELEMETRY"] = "SF_DISABLE_TELEMETRY";
    EnvironmentVariable["SF_DNS_TIMEOUT"] = "SF_DNS_TIMEOUT";
    EnvironmentVariable["SF_DOMAIN_RETRY"] = "SF_DOMAIN_RETRY";
    EnvironmentVariable["SF_IMPROVED_CODE_COVERAGE"] = "SF_IMPROVED_CODE_COVERAGE";
    EnvironmentVariable["SF_ORG_INSTANCE_URL"] = "SF_ORG_INSTANCE_URL";
    EnvironmentVariable["SF_JSON_TO_STDOUT"] = "SF_JSON_TO_STDOUT";
    EnvironmentVariable["SF_LOG_LEVEL"] = "SF_LOG_LEVEL";
    EnvironmentVariable["SF_LOG_ROTATION_COUNT"] = "SF_LOG_ROTATION_COUNT";
    EnvironmentVariable["SF_LOG_ROTATION_PERIOD"] = "SF_LOG_ROTATION_PERIOD";
    EnvironmentVariable["SF_ORG_MAX_QUERY_LIMIT"] = "SF_ORG_MAX_QUERY_LIMIT";
    EnvironmentVariable["SF_MDAPI_TEMP_DIR"] = "SF_MDAPI_TEMP_DIR";
    EnvironmentVariable["SF_NPM_REGISTRY"] = "SF_NPM_REGISTRY";
    EnvironmentVariable["SF_PRECOMPILE_ENABLE"] = "SF_PRECOMPILE_ENABLE";
    EnvironmentVariable["SF_PROJECT_AUTOUPDATE_DISABLE_FOR_PACKAGE_CREATE"] = "SF_PROJECT_AUTOUPDATE_DISABLE_FOR_PACKAGE_CREATE";
    EnvironmentVariable["SF_PROJECT_AUTOUPDATE_DISABLE_FOR_PACKAGE_VERSION_CREATE"] = "SF_PROJECT_AUTOUPDATE_DISABLE_FOR_PACKAGE_VERSION_CREATE";
    EnvironmentVariable["SF_SOURCE_MEMBER_POLLING_TIMEOUT"] = "SF_SOURCE_MEMBER_POLLING_TIMEOUT";
    EnvironmentVariable["SF_USE_GENERIC_UNIX_KEYCHAIN"] = "SF_USE_GENERIC_UNIX_KEYCHAIN";
    EnvironmentVariable["SF_USE_PROGRESS_BAR"] = "SF_USE_PROGRESS_BAR";
    EnvironmentVariable["SF_LAZY_LOAD_MODULES"] = "SF_LAZY_LOAD_MODULES";
    EnvironmentVariable["SF_S3_HOST"] = "SF_S3_HOST";
    EnvironmentVariable["SF_UPDATE_INSTRUCTIONS"] = "SF_UPDATE_INSTRUCTIONS";
    EnvironmentVariable["SF_INSTALLER"] = "SF_INSTALLER";
    EnvironmentVariable["SF_ENV"] = "SF_ENV";
})(EnvironmentVariable = exports.EnvironmentVariable || (exports.EnvironmentVariable = {}));
const getMessage = (environmentVariable) => messages.getMessage((0, change_case_1.camelCase)(environmentVariable));
exports.SUPPORTED_ENV_VARS = {
    [EnvironmentVariable.FORCE_SHOW_SPINNER]: {
        description: getMessage(EnvironmentVariable.FORCE_SHOW_SPINNER),
        synonymOf: null,
    },
    [EnvironmentVariable.FORCE_SPINNER_DELAY]: {
        description: getMessage(EnvironmentVariable.FORCE_SPINNER_DELAY),
        synonymOf: null,
    },
    [EnvironmentVariable.FORCE_OPEN_URL]: {
        description: getMessage(EnvironmentVariable.FORCE_OPEN_URL),
        synonymOf: null,
    },
    [EnvironmentVariable.HTTP_PROXY]: {
        description: getMessage(EnvironmentVariable.HTTP_PROXY),
        synonymOf: null,
    },
    [EnvironmentVariable.HTTPS_PROXY]: {
        description: getMessage(EnvironmentVariable.HTTPS_PROXY),
        synonymOf: null,
    },
    [EnvironmentVariable.NODE_EXTRA_CA_CERTS]: {
        description: getMessage(EnvironmentVariable.NODE_EXTRA_CA_CERTS),
        synonymOf: null,
    },
    [EnvironmentVariable.NODE_TLS_REJECT_UNAUTHORIZED]: {
        description: getMessage(EnvironmentVariable.NODE_TLS_REJECT_UNAUTHORIZED),
        synonymOf: null,
    },
    // sfdx vars
    [EnvironmentVariable.SFDX_ACCESS_TOKEN]: {
        description: getMessage(EnvironmentVariable.SFDX_ACCESS_TOKEN),
        synonymOf: EnvironmentVariable.SF_ACCESS_TOKEN,
    },
    [EnvironmentVariable.SFDX_API_VERSION]: {
        description: getMessage(EnvironmentVariable.SFDX_API_VERSION),
        synonymOf: EnvironmentVariable.SF_ORG_API_VERSION,
    },
    [EnvironmentVariable.SFDX_AUDIENCE_URL]: {
        description: getMessage(EnvironmentVariable.SFDX_AUDIENCE_URL),
        synonymOf: EnvironmentVariable.SF_AUDIENCE_URL,
    },
    [EnvironmentVariable.SFDX_CODE_COVERAGE_REQUIREMENT]: {
        description: getMessage(EnvironmentVariable.SFDX_CODE_COVERAGE_REQUIREMENT),
        synonymOf: EnvironmentVariable.SF_CODE_COVERAGE_REQUIREMENT,
    },
    [EnvironmentVariable.SFDX_CONTENT_TYPE]: {
        description: getMessage(EnvironmentVariable.SFDX_CONTENT_TYPE),
        synonymOf: EnvironmentVariable.SF_CONTENT_TYPE,
    },
    [EnvironmentVariable.SFDX_DEFAULTDEVHUBUSERNAME]: {
        description: getMessage(EnvironmentVariable.SFDX_DEFAULTDEVHUBUSERNAME),
        synonymOf: EnvironmentVariable.SF_TARGET_DEV_HUB,
    },
    [EnvironmentVariable.SFDX_DEFAULTUSERNAME]: {
        description: getMessage(EnvironmentVariable.SFDX_DEFAULTUSERNAME),
        synonymOf: EnvironmentVariable.SF_TARGET_ORG,
    },
    [EnvironmentVariable.SFDX_DISABLE_AUTOUPDATE]: {
        description: getMessage(EnvironmentVariable.SFDX_DISABLE_AUTOUPDATE),
        synonymOf: EnvironmentVariable.SF_DISABLE_AUTOUPDATE,
    },
    [EnvironmentVariable.SFDX_AUTOUPDATE_DISABLE]: {
        description: getMessage(EnvironmentVariable.SFDX_AUTOUPDATE_DISABLE),
        synonymOf: EnvironmentVariable.SF_AUTOUPDATE_DISABLE,
    },
    [EnvironmentVariable.SFDX_DISABLE_SOURCE_MEMBER_POLLING]: {
        description: getMessage(EnvironmentVariable.SFDX_DISABLE_SOURCE_MEMBER_POLLING),
        synonymOf: EnvironmentVariable.SF_DISABLE_SOURCE_MEMBER_POLLING,
    },
    [EnvironmentVariable.SFDX_DISABLE_TELEMETRY]: {
        description: getMessage(EnvironmentVariable.SFDX_DISABLE_TELEMETRY),
        synonymOf: EnvironmentVariable.SF_DISABLE_TELEMETRY,
    },
    [EnvironmentVariable.SFDX_DNS_TIMEOUT]: {
        description: getMessage(EnvironmentVariable.SFDX_DNS_TIMEOUT),
        synonymOf: EnvironmentVariable.SF_DNS_TIMEOUT,
    },
    [EnvironmentVariable.SFDX_DOMAIN_RETRY]: {
        description: getMessage(EnvironmentVariable.SFDX_DOMAIN_RETRY),
        synonymOf: EnvironmentVariable.SF_DOMAIN_RETRY,
    },
    [EnvironmentVariable.SFDX_IMPROVED_CODE_COVERAGE]: {
        description: getMessage(EnvironmentVariable.SFDX_IMPROVED_CODE_COVERAGE),
        synonymOf: EnvironmentVariable.SF_IMPROVED_CODE_COVERAGE,
    },
    [EnvironmentVariable.SFDX_INSTANCE_URL]: {
        description: getMessage(EnvironmentVariable.SFDX_INSTANCE_URL),
        synonymOf: EnvironmentVariable.SF_ORG_INSTANCE_URL,
    },
    [EnvironmentVariable.SFDX_JSON_TO_STDOUT]: {
        description: getMessage(EnvironmentVariable.SFDX_JSON_TO_STDOUT),
        synonymOf: EnvironmentVariable.SF_JSON_TO_STDOUT,
    },
    [EnvironmentVariable.SFDX_LOG_LEVEL]: {
        description: getMessage(EnvironmentVariable.SFDX_LOG_LEVEL),
        synonymOf: EnvironmentVariable.SF_LOG_LEVEL,
    },
    [EnvironmentVariable.SFDX_LOG_ROTATION_COUNT]: {
        description: getMessage(EnvironmentVariable.SFDX_LOG_ROTATION_COUNT),
        synonymOf: EnvironmentVariable.SF_LOG_ROTATION_COUNT,
    },
    [EnvironmentVariable.SFDX_LOG_ROTATION_PERIOD]: {
        description: getMessage(EnvironmentVariable.SFDX_LOG_ROTATION_PERIOD),
        synonymOf: EnvironmentVariable.SF_LOG_ROTATION_PERIOD,
    },
    [EnvironmentVariable.SFDX_MAX_QUERY_LIMIT]: {
        description: getMessage(EnvironmentVariable.SFDX_MAX_QUERY_LIMIT),
        synonymOf: EnvironmentVariable.SF_ORG_MAX_QUERY_LIMIT,
    },
    [EnvironmentVariable.SFDX_MDAPI_TEMP_DIR]: {
        description: getMessage(EnvironmentVariable.SFDX_MDAPI_TEMP_DIR),
        synonymOf: EnvironmentVariable.SF_MDAPI_TEMP_DIR,
    },
    [EnvironmentVariable.SFDX_NPM_REGISTRY]: {
        description: getMessage(EnvironmentVariable.SFDX_NPM_REGISTRY),
        synonymOf: EnvironmentVariable.SF_NPM_REGISTRY,
    },
    [EnvironmentVariable.SFDX_PRECOMPILE_ENABLE]: {
        description: getMessage(EnvironmentVariable.SFDX_PRECOMPILE_ENABLE),
        synonymOf: EnvironmentVariable.SF_PRECOMPILE_ENABLE,
    },
    [EnvironmentVariable.SFDX_PROJECT_AUTOUPDATE_DISABLE_FOR_PACKAGE_CREATE]: {
        description: getMessage(EnvironmentVariable.SFDX_PROJECT_AUTOUPDATE_DISABLE_FOR_PACKAGE_CREATE),
        synonymOf: EnvironmentVariable.SF_PROJECT_AUTOUPDATE_DISABLE_FOR_PACKAGE_CREATE,
    },
    [EnvironmentVariable.SFDX_PROJECT_AUTOUPDATE_DISABLE_FOR_PACKAGE_VERSION_CREATE]: {
        description: messages.getMessage((0, change_case_1.camelCase)(EnvironmentVariable.SFDX_PROJECT_AUTOUPDATE_DISABLE_FOR_PACKAGE_VERSION_CREATE)),
        synonymOf: EnvironmentVariable.SF_PROJECT_AUTOUPDATE_DISABLE_FOR_PACKAGE_VERSION_CREATE,
    },
    [EnvironmentVariable.SFDX_REST_DEPLOY]: {
        description: getMessage(EnvironmentVariable.SFDX_REST_DEPLOY),
        synonymOf: null,
    },
    [EnvironmentVariable.SFDX_SOURCE_MEMBER_POLLING_TIMEOUT]: {
        description: getMessage(EnvironmentVariable.SFDX_SOURCE_MEMBER_POLLING_TIMEOUT),
        synonymOf: EnvironmentVariable.SF_SOURCE_MEMBER_POLLING_TIMEOUT,
    },
    [EnvironmentVariable.SFDX_USE_GENERIC_UNIX_KEYCHAIN]: {
        description: getMessage(EnvironmentVariable.SFDX_USE_GENERIC_UNIX_KEYCHAIN),
        synonymOf: EnvironmentVariable.SF_USE_GENERIC_UNIX_KEYCHAIN,
    },
    [EnvironmentVariable.SFDX_USE_PROGRESS_BAR]: {
        description: getMessage(EnvironmentVariable.SFDX_USE_PROGRESS_BAR),
        synonymOf: EnvironmentVariable.SF_USE_PROGRESS_BAR,
    },
    [EnvironmentVariable.SFDX_LAZY_LOAD_MODULES]: {
        description: getMessage(EnvironmentVariable.SFDX_USE_PROGRESS_BAR),
        synonymOf: EnvironmentVariable.SF_LAZY_LOAD_MODULES,
    },
    [EnvironmentVariable.SFDX_S3_HOST]: {
        description: getMessage(EnvironmentVariable.SFDX_S3_HOST),
        synonymOf: EnvironmentVariable.SF_S3_HOST,
    },
    [EnvironmentVariable.SFDX_UPDATE_INSTRUCTIONS]: {
        description: getMessage(EnvironmentVariable.SFDX_UPDATE_INSTRUCTIONS),
        synonymOf: null,
    },
    [EnvironmentVariable.SFDX_INSTALLER]: {
        description: getMessage(EnvironmentVariable.SFDX_INSTALLER),
        synonymOf: null,
    },
    [EnvironmentVariable.SFDX_ENV]: {
        description: getMessage(EnvironmentVariable.SFDX_ENV),
        synonymOf: null,
    },
    [EnvironmentVariable.SF_TARGET_ORG]: {
        description: getMessage(EnvironmentVariable.SF_TARGET_ORG),
        synonymOf: EnvironmentVariable.SFDX_DEFAULTUSERNAME,
    },
    [EnvironmentVariable.SF_TARGET_DEV_HUB]: {
        description: getMessage(EnvironmentVariable.SF_TARGET_DEV_HUB),
        synonymOf: EnvironmentVariable.SFDX_DEFAULTDEVHUBUSERNAME,
    },
    // sf vars
    [EnvironmentVariable.SF_ACCESS_TOKEN]: {
        description: getMessage(EnvironmentVariable.SF_ACCESS_TOKEN),
        synonymOf: null,
    },
    [EnvironmentVariable.SF_ORG_API_VERSION]: {
        description: getMessage(EnvironmentVariable.SF_ORG_API_VERSION),
        synonymOf: EnvironmentVariable.SFDX_API_VERSION,
    },
    [EnvironmentVariable.SF_AUDIENCE_URL]: {
        description: getMessage(EnvironmentVariable.SF_AUDIENCE_URL),
        synonymOf: null,
    },
    [EnvironmentVariable.SF_CODE_COVERAGE_REQUIREMENT]: {
        description: getMessage(EnvironmentVariable.SF_CODE_COVERAGE_REQUIREMENT),
        synonymOf: null,
    },
    [EnvironmentVariable.SF_CONTENT_TYPE]: {
        description: getMessage(EnvironmentVariable.SF_CONTENT_TYPE),
        synonymOf: null,
    },
    [EnvironmentVariable.SF_DISABLE_AUTOUPDATE]: {
        description: getMessage(EnvironmentVariable.SF_DISABLE_AUTOUPDATE),
        synonymOf: null,
    },
    [EnvironmentVariable.SF_AUTOUPDATE_DISABLE]: {
        description: getMessage(EnvironmentVariable.SF_AUTOUPDATE_DISABLE),
        synonymOf: null,
    },
    [EnvironmentVariable.SF_DISABLE_SOURCE_MEMBER_POLLING]: {
        description: getMessage(EnvironmentVariable.SF_DISABLE_SOURCE_MEMBER_POLLING),
        synonymOf: null,
    },
    [EnvironmentVariable.SF_DISABLE_TELEMETRY]: {
        description: getMessage(EnvironmentVariable.SF_DISABLE_TELEMETRY),
        synonymOf: null,
    },
    [EnvironmentVariable.SF_DNS_TIMEOUT]: {
        description: getMessage(EnvironmentVariable.SF_DNS_TIMEOUT),
        synonymOf: null,
    },
    [EnvironmentVariable.SF_DOMAIN_RETRY]: {
        description: getMessage(EnvironmentVariable.SF_DOMAIN_RETRY),
        synonymOf: null,
    },
    [EnvironmentVariable.SF_IMPROVED_CODE_COVERAGE]: {
        description: getMessage(EnvironmentVariable.SF_IMPROVED_CODE_COVERAGE),
        synonymOf: null,
    },
    [EnvironmentVariable.SF_ORG_INSTANCE_URL]: {
        description: getMessage(EnvironmentVariable.SF_ORG_INSTANCE_URL),
        synonymOf: null,
    },
    [EnvironmentVariable.SF_JSON_TO_STDOUT]: {
        description: getMessage(EnvironmentVariable.SF_JSON_TO_STDOUT),
        synonymOf: null,
    },
    [EnvironmentVariable.SF_LOG_LEVEL]: {
        description: getMessage(EnvironmentVariable.SF_LOG_LEVEL),
        synonymOf: null,
    },
    [EnvironmentVariable.SF_LOG_ROTATION_COUNT]: {
        description: getMessage(EnvironmentVariable.SF_LOG_ROTATION_COUNT),
        synonymOf: null,
    },
    [EnvironmentVariable.SF_LOG_ROTATION_PERIOD]: {
        description: getMessage(EnvironmentVariable.SF_LOG_ROTATION_PERIOD),
        synonymOf: null,
    },
    [EnvironmentVariable.SF_ORG_MAX_QUERY_LIMIT]: {
        description: getMessage(EnvironmentVariable.SF_ORG_MAX_QUERY_LIMIT),
        synonymOf: EnvironmentVariable.SFDX_MAX_QUERY_LIMIT,
    },
    [EnvironmentVariable.SF_MDAPI_TEMP_DIR]: {
        description: getMessage(EnvironmentVariable.SF_MDAPI_TEMP_DIR),
        synonymOf: null,
    },
    [EnvironmentVariable.SF_NPM_REGISTRY]: {
        description: getMessage(EnvironmentVariable.SF_NPM_REGISTRY),
        synonymOf: null,
    },
    [EnvironmentVariable.SF_PRECOMPILE_ENABLE]: {
        description: getMessage(EnvironmentVariable.SF_PRECOMPILE_ENABLE),
        synonymOf: null,
    },
    [EnvironmentVariable.SF_PROJECT_AUTOUPDATE_DISABLE_FOR_PACKAGE_CREATE]: {
        description: getMessage(EnvironmentVariable.SF_PROJECT_AUTOUPDATE_DISABLE_FOR_PACKAGE_CREATE),
        synonymOf: null,
    },
    [EnvironmentVariable.SF_PROJECT_AUTOUPDATE_DISABLE_FOR_PACKAGE_VERSION_CREATE]: {
        description: messages.getMessage((0, change_case_1.camelCase)(EnvironmentVariable.SF_PROJECT_AUTOUPDATE_DISABLE_FOR_PACKAGE_VERSION_CREATE)),
        synonymOf: null,
    },
    [EnvironmentVariable.SF_SOURCE_MEMBER_POLLING_TIMEOUT]: {
        description: getMessage(EnvironmentVariable.SF_SOURCE_MEMBER_POLLING_TIMEOUT),
        synonymOf: null,
    },
    [EnvironmentVariable.SF_USE_GENERIC_UNIX_KEYCHAIN]: {
        description: getMessage(EnvironmentVariable.SF_USE_GENERIC_UNIX_KEYCHAIN),
        synonymOf: null,
    },
    [EnvironmentVariable.SF_USE_PROGRESS_BAR]: {
        description: getMessage(EnvironmentVariable.SF_USE_PROGRESS_BAR),
        synonymOf: null,
    },
    [EnvironmentVariable.SF_LAZY_LOAD_MODULES]: {
        description: getMessage(EnvironmentVariable.SF_LAZY_LOAD_MODULES),
        synonymOf: null,
    },
    [EnvironmentVariable.SF_S3_HOST]: {
        description: getMessage(EnvironmentVariable.SF_S3_HOST),
        synonymOf: null,
    },
    [EnvironmentVariable.SF_UPDATE_INSTRUCTIONS]: {
        description: getMessage(EnvironmentVariable.SF_UPDATE_INSTRUCTIONS),
        synonymOf: null,
    },
    [EnvironmentVariable.SF_INSTALLER]: {
        description: getMessage(EnvironmentVariable.SF_INSTALLER),
        synonymOf: null,
    },
    [EnvironmentVariable.SF_ENV]: {
        description: getMessage(EnvironmentVariable.SF_ENV),
        synonymOf: null,
    },
};
class EnvVars extends kit_1.Env {
    constructor(env = process.env) {
        super(env);
        this.resolve();
    }
    static propertyToEnvName(property, prefix = EnvVars.defaultPrefix()) {
        return `${prefix || ''}${(0, change_case_1.snakeCase)(property).toUpperCase()}`;
    }
    static defaultPrefix() {
        if (process.argv[0].startsWith('sfdx'))
            return 'SFDX_';
        if (process.argv[0].startsWith('sf'))
            return 'SF_';
        return 'SFDX_';
    }
    getPropertyFromEnv(property, prefix = EnvVars.defaultPrefix()) {
        var _a;
        const envName = EnvVars.propertyToEnvName(property, prefix);
        const synonym = (_a = exports.SUPPORTED_ENV_VARS[envName]) === null || _a === void 0 ? void 0 : _a.synonymOf;
        return this.get(envName) || this.get(synonym);
    }
    asDictionary() {
        return this.entries().reduce((accumulator, [key, value]) => {
            accumulator[key] = value;
            return accumulator;
        }, {});
    }
    asMap() {
        return this.entries().reduce((accumulator, [key, value]) => {
            accumulator.set(key, value);
            return accumulator;
        }, new Map());
    }
    resolve() {
        this.entries().forEach(([key, value]) => {
            if (exports.SUPPORTED_ENV_VARS[key]) {
                // cross populate value to synonym if synonym exists
                if (exports.SUPPORTED_ENV_VARS[key].synonymOf) {
                    const synonym = exports.SUPPORTED_ENV_VARS[key].synonymOf;
                    // set synonym only if it is in the map and running in interoperability mode
                    if (synonym && global_1.Global.SFDX_INTEROPERABILITY) {
                        this.setString(synonym, value);
                    }
                }
            }
        });
    }
    get(envName) {
        return this.asDictionary()[envName];
    }
}
exports.EnvVars = EnvVars;
exports.envVars = new EnvVars();
//# sourceMappingURL=envVars.js.map